-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic;
    opb_external_memory_0_OMA_DATA_O_pin : out std_logic_vector(0 to 31);
    opb_external_memory_0_OMA_DATA_I_pin : in std_logic_vector(0 to 31);
    opb_external_memory_0_OMA_VALID_pin : in std_logic;
    opb_external_memory_0_OMA_ADDRESS_pin : out std_logic_vector(0 to 31);
    opb_external_memory_0_OMA_RW_pin : out std_logic;
    opb_external_memory_0_OMA_ACTIVE_pin : out std_logic;
    opb_external_memory_0_LEDS_DEBUG_pin : out std_logic_vector(0 to 15);
    opb_external_memory_0_OMA_BE_pin : out std_logic_vector(0 to 3)
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      sys_clk_pin : in std_logic;
      sys_rst_pin : in std_logic;
      opb_external_memory_0_OMA_DATA_O_pin : out std_logic_vector(0 to 31);
      opb_external_memory_0_OMA_DATA_I_pin : in std_logic_vector(0 to 31);
      opb_external_memory_0_OMA_VALID_pin : in std_logic;
      opb_external_memory_0_OMA_ADDRESS_pin : out std_logic_vector(0 to 31);
      opb_external_memory_0_OMA_RW_pin : out std_logic;
      opb_external_memory_0_OMA_ACTIVE_pin : out std_logic;
      opb_external_memory_0_LEDS_DEBUG_pin : out std_logic_vector(0 to 15);
      opb_external_memory_0_OMA_BE_pin : out std_logic_vector(0 to 3)
    );
  end component;

begin

  system_i : system
    port map (
      sys_clk_pin => sys_clk_pin,
      sys_rst_pin => sys_rst_pin,
      opb_external_memory_0_OMA_DATA_O_pin => opb_external_memory_0_OMA_DATA_O_pin,
      opb_external_memory_0_OMA_DATA_I_pin => opb_external_memory_0_OMA_DATA_I_pin,
      opb_external_memory_0_OMA_VALID_pin => opb_external_memory_0_OMA_VALID_pin,
      opb_external_memory_0_OMA_ADDRESS_pin => opb_external_memory_0_OMA_ADDRESS_pin,
      opb_external_memory_0_OMA_RW_pin => opb_external_memory_0_OMA_RW_pin,
      opb_external_memory_0_OMA_ACTIVE_pin => opb_external_memory_0_OMA_ACTIVE_pin,
      opb_external_memory_0_LEDS_DEBUG_pin => opb_external_memory_0_LEDS_DEBUG_pin,
      opb_external_memory_0_OMA_BE_pin => opb_external_memory_0_OMA_BE_pin
    );

end architecture STRUCTURE;

