-------------------------------------------------------------------------------
-- opb_offchip_memory_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library opb_offchip_memory_v1_00_c;
use opb_offchip_memory_v1_00_c.All;

entity opb_offchip_memory_0_wrapper is
  port (
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    Sl_DBus : out std_logic_vector(0 to 31);
    Sl_errAck : out std_logic;
    Sl_retry : out std_logic;
    Sl_toutSup : out std_logic;
    Sl_xferAck : out std_logic;
    OPB_ABus : in std_logic_vector(0 to 31);
    OPB_BE : in std_logic_vector(0 to 3);
    OPB_DBus : in std_logic_vector(0 to 31);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic;
    OMA_DATA_O : out std_logic_vector(0 to 31);
    OMA_DATA_I : in std_logic_vector(0 to 31);
    OMA_VALID : in std_logic;
    OMA_ADDRESS : out std_logic_vector(0 to 31);
    OMA_RW : out std_logic;
    OMA_ACTIVE : out std_logic;
    LEDS_DEBUG : out std_logic_vector(0 to 15)
  );
end opb_offchip_memory_0_wrapper;

architecture STRUCTURE of opb_offchip_memory_0_wrapper is

  component opb_offchip_memory is
    generic (
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_OPB_AWIDTH : INTEGER;
      C_OPB_DWIDTH : INTEGER;
      C_USER_ID_CODE : INTEGER;
      C_FAMILY : STRING;
      C_AR0_BASEADDR : std_logic_vector;
      C_AR0_HIGHADDR : std_logic_vector
    );
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      Sl_DBus : out std_logic_vector(0 to (C_OPB_DWIDTH-1));
      Sl_errAck : out std_logic;
      Sl_retry : out std_logic;
      Sl_toutSup : out std_logic;
      Sl_xferAck : out std_logic;
      OPB_ABus : in std_logic_vector(0 to (C_OPB_AWIDTH-1));
      OPB_BE : in std_logic_vector(0 to ((C_OPB_DWIDTH/8)-1));
      OPB_DBus : in std_logic_vector(0 to (C_OPB_DWIDTH-1));
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OMA_DATA_O : out std_logic_vector(0 to (C_OPB_DWIDTH-1));
      OMA_DATA_I : in std_logic_vector(0 to (C_OPB_DWIDTH-1));
      OMA_VALID : in std_logic;
      OMA_ADDRESS : out std_logic_vector(0 to (C_OPB_AWIDTH-1));
      OMA_RW : out std_logic;
      OMA_ACTIVE : out std_logic;
      LEDS_DEBUG : out std_logic_vector(0 to 15)
    );
  end component;

begin

  opb_offchip_memory_0 : opb_offchip_memory
    generic map (
      C_BASEADDR => X"ffffffff",
      C_HIGHADDR => X"00000000",
      C_OPB_AWIDTH => 32,
      C_OPB_DWIDTH => 32,
      C_USER_ID_CODE => 3,
      C_FAMILY => "virtexe",
      C_AR0_BASEADDR => X"00000000",
      C_AR0_HIGHADDR => X"0000FFFF"
    )
    port map (
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      Sl_DBus => Sl_DBus,
      Sl_errAck => Sl_errAck,
      Sl_retry => Sl_retry,
      Sl_toutSup => Sl_toutSup,
      Sl_xferAck => Sl_xferAck,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_DBus => OPB_DBus,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr,
      OMA_DATA_O => OMA_DATA_O,
      OMA_DATA_I => OMA_DATA_I,
      OMA_VALID => OMA_VALID,
      OMA_ADDRESS => OMA_ADDRESS,
      OMA_RW => OMA_RW,
      OMA_ACTIVE => OMA_ACTIVE,
      LEDS_DEBUG => LEDS_DEBUG
    );

end architecture STRUCTURE;

