#  Simulation Model Generator
#  Xilinx EDK 8.2 EDK_Im.14
#  Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
#
#  File     system_list.do (Thu Jun  7 10:25:24 2007)
#
#  List Window DO Script File
#
#  List Window DO script files setup the ModelSim List window
#  display for viewing results of the simulation in a tabular
#  format. Comment or uncomment commands to change the set of
#  data values viewed.
#
echo  "Setting up List window display ..."

if { ![info exists xcmdc] } {echo "Warning : c compile command was not run"}
if { ![info exists xcmds] } {echo "Warning : s simulate command was not run"}

onerror { resume }

#  Because EDK did not create the testbench, the user
#  specifies the path to the device under test, $tbpath.
#
if { [info exists PathSeparator] } { set ps $PathSeparator } else { set ps "/" }
if { ![info exists tbpath] } { set tbpath "${ps}system" }

#
#  Display top-level ports
#
set binopt {-bin}
set hexopt {-hex}
eval add list $binopt $tbpath${ps}sys_clk_pin
eval add list $binopt $tbpath${ps}sys_rst_pin
eval add list $hexopt $tbpath${ps}opb_external_memory_0_OMA_DATA_O_pin
eval add list $hexopt $tbpath${ps}opb_external_memory_0_OMA_DATA_I_pin
eval add list $binopt $tbpath${ps}opb_external_memory_0_OMA_VALID_pin
eval add list $hexopt $tbpath${ps}opb_external_memory_0_OMA_ADDRESS_pin
eval add list $binopt $tbpath${ps}opb_external_memory_0_OMA_RW_pin
eval add list $binopt $tbpath${ps}opb_external_memory_0_OMA_ACTIVE_pin
eval add list $hexopt $tbpath${ps}opb_external_memory_0_LEDS_DEBUG_pin
eval add list $hexopt $tbpath${ps}opb_external_memory_0_OMA_BE_pin

#
#  Display bus signal ports
#
do fsl_v20_0_list.do

do lmb_v10_0_list.do

do lmb_v10_1_list.do

do mb_opb_list.do

#
#  Display processor ports
#
do microblaze_0_list.do

#
#  Display processor registers
#

#  Processor registers cannot be displayed for:
#  Module   microblaze_0_wrapper
#  Instance microblaze_0
#  Register display support will be added in the EDK 9.1i release

#
#  Display IP and peripheral ports
#
do bram_block_0_list.do

do opb_external_memory_0_list.do

do cpu_identifier_0_list.do

do lmb_bram_if_cntlr_0_list.do

do lmb_bram_if_cntlr_1_list.do


#  List window configuration information
#
configure list -delta                 none
configure list -usesignaltriggers     0

#  Define the simulation strobe and period, if used.

configure list -usestrobe             0
configure list -strobestart           {0 ps}  -strobeperiod {0 ps}

configure list -usegating             1
configure list -gateexpr              $tbpath${ps}sys_clk_pin'rising

#  List window setup complete
#
echo  "List window display setup done."
