#  Simulation Model Generator
#  Xilinx EDK 8.2 EDK_Im.14
#  Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
#
#  File     system_wave.do (Thu Jun  7 10:25:24 2007)
#
#  Wave Window DO Script File
#
#  Wave Window DO script files setup the ModelSim Wave window
#  display for viewing results of the simulation in a graphic
#  format. Comment or uncomment commands to change the set of
#  signals viewed.
#
echo  "Setting up Wave window display ..."

if { ![info exists xcmdc] } {echo "Warning : c compile command was not run"}
if { ![info exists xcmds] } {echo "Warning : s simulate command was not run"}

#  Because EDK did not create the testbench, the user
#  specifies the path to the device under test, $tbpath.
#
if { [info exists PathSeparator] } { set ps $PathSeparator } else { set ps "/" }
if { ![info exists tbpath] } { set tbpath "${ps}system" }

#
#  Display top-level ports
#
set binopt {-logic}
set hexopt {-literal -hex}
eval add wave -noupdate -divider {"top-level ports"}
eval add wave -noupdate $binopt $tbpath${ps}sys_clk_pin
eval add wave -noupdate $binopt $tbpath${ps}sys_rst_pin
eval add wave -noupdate $hexopt $tbpath${ps}opb_external_memory_0_OMA_DATA_O_pin
eval add wave -noupdate $hexopt $tbpath${ps}opb_external_memory_0_OMA_DATA_I_pin
eval add wave -noupdate $binopt $tbpath${ps}opb_external_memory_0_OMA_VALID_pin
eval add wave -noupdate $hexopt $tbpath${ps}opb_external_memory_0_OMA_ADDRESS_pin
eval add wave -noupdate $binopt $tbpath${ps}opb_external_memory_0_OMA_RW_pin
eval add wave -noupdate $binopt $tbpath${ps}opb_external_memory_0_OMA_ACTIVE_pin
eval add wave -noupdate $hexopt $tbpath${ps}opb_external_memory_0_LEDS_DEBUG_pin
eval add wave -noupdate $hexopt $tbpath${ps}opb_external_memory_0_OMA_BE_pin

#
#  Display bus signal ports
#
do fsl_v20_0_wave.do

do lmb_v10_0_wave.do

do lmb_v10_1_wave.do

do mb_opb_wave.do

#
#  Display processor ports
#
do microblaze_0_wave.do

#
#  Display processor registers
#

#  Processor registers cannot be displayed for:
#  Module   microblaze_0_wrapper
#  Instance microblaze_0
#  Register display support will be added in the EDK 9.1i release

#
#  Display IP and peripheral ports
#
do bram_block_0_wave.do

do opb_external_memory_0_wave.do

do cpu_identifier_0_wave.do

do lmb_bram_if_cntlr_0_wave.do

do lmb_bram_if_cntlr_1_wave.do


#  Wave window configuration information
#
configure  wave -justifyvalue          right
configure  wave -signalnamewidth       1

TreeUpdate [SetDefaultTree]

#  Wave window setup complete
#
echo  "Wave window display setup done."
