/*
 * CPU Controller for Master Thesis Project
 * 2006 - Kenneth Oestby <kenneo@idi.ntnu.no>
 *
 *
 */

#include <dimesdl.h>

#ifndef __CPU_H

#define BUFFER_SIZE	2048
#define CLOCK_NUM	2
#define CLOCK_FREQ	40

typedef struct {
	DIME_HANDLE 	card;
	LOCATE_HANDLE	locate;
	DWORD		leds;
	unsigned int sendBuffer[BUFFER_SIZE];
	unsigned int recvBuffer[BUFFER_SIZE];
	DIME_MEMHANDLE	send;
	DIME_MEMHANDLE	recv;
	DIME_DMAHANDLE	dma;
}CPU;

static CPU cpu;

int openCard(int cardNum, char *bitfile);
int setupDMA();
int closeCard();
int configureCard(char *filename);
int writeCard(int size);
int readCard(int size);
int resetCard();


unsigned int getWord32();
unsigned int writeWord32(unsigned int word);


#endif
