
#ifndef __MEMORY_H
#define __MEMORY_H

#define START_MEM 20
#define GROW_RATE 20 

// #define MEM_SIZE 0x4FC000C
#define MEM_SIZE 0x5000000

#include "rb.h"

struct _MemBlock {
	unsigned int addr; 
	unsigned char data;
	struct _MemBlock *prev, *next;
}; 

typedef struct _MemBlock MemBlock;

typedef struct {
	unsigned int max_addr;
	unsigned int mem_used;
	unsigned int mem_size;
	MemBlock *data;
	struct rb_table *table;
	unsigned char *bytes;
}Memory;


Memory *mem_init();
int mem_load(Memory *m, char *filename);
unsigned int mem_read(unsigned int addr,int *error, Memory *m);
unsigned int mem_write(unsigned int addr, unsigned int data,unsigned char byteEnabled, Memory *m);
unsigned int mem_writeByte(unsigned int addr, unsigned char data, Memory *m);
int mem_clean(Memory *m);
int mem_print(Memory *m);
int mem_zero(Memory *m, unsigned int offset);

#endif

