/**
 * Several utility functions
 * to make the life easier
 *
 * 2007 - Kenneth Oestby <kenneo@idi.ntnu.no>
 *
 */

static char isBigEndian = 1; 

unsigned long ByteSwap2 (unsigned long nLongNumber)
{
	return (((nLongNumber&0x000000FF)<<24)+((nLongNumber&0x0000FF00)<<8)+
	      ((nLongNumber&0x00FF0000)>>8)+((nLongNumber&0xFF000000)>>24));
}

unsigned int CoreToHostI(unsigned int i){
	if ( isBigEndian )
		return i; 

	return ByteSwap2(i);	
}
unsigned int HostToCoreI(unsigned int i){
	if ( isBigEndian )
		return i; 

	return ByteSwap2(i);	
}

/*
 * Reverses the integer..
 */
unsigned int reverseInt(unsigned int number){
	int i = 0, j = 0;
        unsigned int tmp = 0;

        for(i=sizeof(int)*8-1,j=0;i>=0;i--,j++)
                tmp |= ((number >> i) & 1) << j;

        return tmp;
}

unsigned char reverseInt8(unsigned char number){
	int i = 0, j = 0;
        unsigned char tmp = 0;

        for(i=sizeof(unsigned char)*8-1,j=0;i>=0;i--,j++)
                tmp |= ((number >> i) & 1) << j;

        return tmp;
}
